/* Datei:  comsf_sonar.c
 * Author: gkemnitz
 * Datum:  24.10.2015
 *
 * Quellprogramm fr den Gertetreiber comsf_sonar
 *
 * Sonar an JD unten; Jumper JDX gekreuzt
 */  

#include "comsf_sonar.h"

uint16_t snr_val;
uint8_t  snr_state;

void sonar_init(){
  // Initialisierung von USART1 Empfang
  UCSR1C=0b110;               // bertragungsformat 8N1
  UBRR1=51;                   // 9600 Baud
  UCSR1B|=(1<<RXEN1);         // Empfnger ein
  DDRD  |= 1<<PD5;            // PD5 Ausgang
  PORTD |= 1<<PD5;            // Sonar einschalten
  snr_state =0;
}

void sonar_step(){            // Schrittfunktion
  if (!(UCSR1A & (1<<RXC1)))  // wenn kein neues zeichen
    return;                   // beenden
  uint8_t dat = UDR1;         // sonst Zeichen lesen
  if (snr_state==0 && dat=='R'){// Kante von Z0 nach Z1  
    snr_state = 1;       
    snr_val   = 0;   
  }                           //"Ziff"-Kanten
  else if (snr_state>0 && snr_state<4 && dat>='0' && dat<='9'){
    snr_val = (snr_val*10) + (dat-'0');
    snr_state++;
    return;
  }                           //Kante von Z4 nach Z5
  else if(snr_state==4 && dat==0x0D)
    snr_state = 5;
  else if (snr_state<5)
    snr_state = 0;            //"sonst"-Kanten
}

uint8_t sonar_get(uint16_t *sptr){
  if (snr_state>=5) {         // wenn neuer Wert da,
    *sptr = snr_val;          // ausgeben
    snr_state = 0;            // Zustand rcksetzen
    return 1;                 // Rcksprung mit "wahr"
  }
  else                        // sonst 
   return 0;                  // Rcksprung mit "falsch"
}
