/* Datei:  test_pwm.c
 * Autor: gkemnitz
 * letzte nderung:  02.11.2015
 *
 * Testprogramm fr die pwm-Ansteuerung der Motoren
 *
 * Die Motoren sind ber zwei H-Brcken PModHB5 und
 * Splitter-Kabel an JL und PmodUSBUSART an JH oben 
 * anzuschliessen. Motor A  ist oben.
 * PmodUSBUSART an JH oben anschliessen.
 * JHX und JLX "gekreuzt (=)"
 */ 

#include "comir_pc.h"
#include "comir_tmr.h"
#include "pwm.h"
#include <avr/interrupt.h>

uint8_t msg[COM_PC_RMSG_LEN];

int main(void){
  int16_t pwm;
	uint16_t time;
  com_pc_init();          // Treiber comir_pc und
  pwm_init();             // pwm initialisieren
	tmr_init();
  sei();				  // Interrupts global ein

  while(1){
    if (com_pc_get(msg)){ // wenn neue Nachricht
      pwm = msg[0]<<8 | msg[1];
      pwm_set_R(pwm);     // PWM-Wert fr Motor R
      pwm = msg[2]<<8 | msg[3];
      pwm_set_L(pwm);     // PWM-Wert fr Motor L
			
      time = msg[4]<<8 | msg[5];
      tmr_start(time, 0); // Timer Kanal 0 starten
      pwm_start();        // PWM (Motoren) starten
    }
    if (!tmr_restzeit(0)) // wenn Timer abgelaufen,
    pwm_stop();           // PWM (Motoren) aus 
  }
}